function User(socket, authenticatedDefault) {
  this.registered = false
  this.authenticated = authenticatedDefault
  this.nickname = undefined
  this.connection = socket
  this.realname = ""
  this.username = ""

  this.setNickname = function(nickname) {
    if (this.nickname !== undefined) {
      this.sendRaw(`:${this.nickname} NICK ${nickname}`)
    }
    this.nickname = nickname
  }

  this.getNickname = function(nickname) {
    return this.nickname
  }

  this.register = function(username, realname) {
    if (!this.authenticated) {
      this.connection.destroy()
    }
    this.username = username
    this.realname = realname
    this.registered = true
  }

  this.getAddress = function() {
    return this.connection.address().address
  }

    this.closeConnection = function () {
        this.connection.destroy()
    }


    this.sendMsg = function (from, message, to = this.nickname) {
        this.sendRaw(`:${from.nickname} PRIVMSG ${to} :${message}`, "ascii")
    }
    this.sendRaw = function(message) {
      this.connection.write(`${message}\r\n`, "ascii")
    }
}

module.exports = User
