const assert = require('assert');
const EventEmitter = require('events');
const IRCServer = require("../src/server.js");

describe("hexchat", function () {
    it("should handle hexchat inital command list", function (done) {
        const server = IRCServer.create()
        let mockedSock = new EventEmitter()
        mockedSock.address = function() {
          return { port: 12346, family: 'IPv4', address: '127.0.0.1' }
        }
        mockedSock.write = function (data) {
            assert.equal(data.toString("ascii"), ":irc.example.com 001 some_nick :Welcome to the example IRC Project some_nick!~guest@127.0.0.1\r\n")
            done()
        }
        mockedSock.destroy = function () {
            done("Destroyed socket without answering")
        }

        server.emit("connection", mockedSock)
        mockedSock.emit('data', Buffer.from("CAP LS 302\r\nNICK some_nick\r\nUSER guest tolmoon tolsun :Ronnie Reagan\r\n", "ascii"))
    })
})
